(function() {
  var directive;

  directive = function() {
    directive = {
      templateUrl: "/partials/directives/value.html",
      replace: true,
      transclude: false,
      restrict: 'E',
      scope: {
        value: "=",
        docId: "=",
        key: "=",
        expended: "="
      },
      controller: [
        "$scope", "$routeParams", function($scope, $routeParams) {
          $scope.isSmallString = function(str) {
            var rgx;
            if (!_.isString(str)) {
              return false;
            }
            rgx = str.match(/\n/g) || [];
            return str.length < 1000 && rgx.length < 20;
          };
          $scope.isSmallObject = function(obj) {
            return $scope.isSmallString(JSON.stringify(obj, null, 4));
          };
          $scope.getSmallPrefix = function(str) {
            if (_.isString(str)) {
              return str.substr(0, 500) + "...";
            }
            return "";
          };
          $scope.url = function() {
            var rp, s;
            rp = $routeParams;
            s = $scope;
            return "#/" + rp.server + "/" + rp.database + "/" + rp.collection + "/_id/" + s.docId + "/field/" + s.key;
          };
          $scope.valueLength = _.isObject($scope.value) ? _.keys($scope.value).length : $scope.value.length;
          $scope.isString = _.isString($scope.value);
          $scope.isNumber = _.isNumber($scope.value);
          $scope.isObject = _.isObject($scope.value);
          $scope.isArray = _.isArray($scope.value);
          return $scope.isBoolean = _.isBoolean($scope.value);
        }
      ]
    };
    return directive;
  };

  directives.directive("vulValue", [directive]);

}).call(this);
